import express from "express";

import db from "../../lib/sql";

const queries = {
  getlangs: "select * from `languages`",
  add:      "insert into `pastes` (`uuid`,`lang`,`desc`,`paste`,`hidden`,`reply`) "
          + "values (LEFT(UUID(), 8), ?, ?, ?, ?, ?)",
  getuuid:  "select `uuid` from `pastes` where `id` = ? limit 1"
};
let languages = new Map();
db.exec(queries.getlangs)
  .then(rows => rows.forEach(r => languages.set(r.id, r.name)))
  .catch(err => console.log(err));

export default express.Router()
  .get("/", (req, res) => res.render("index", { languages: [...languages.values()] }))
  .post("/", (req, res) => {
    const data = {
      desc: req.body.desc || "",
      content: req.body.content || false,
      lang: languages.getKey(req.body.lang) || 1,
      hidden: req.body.hidden || 0,
      reply: req.body.reply || 0
    };
    if(!data.content)
      return res.render("index", { languages: [...languages.values()], notification: "nope" });
    db.exec(queries.add, [
      data.lang,
      data.desc,
      new Buffer(data.content).toString("base64"),
      data.hidden,
      data.reply
    ]).then(insert => db.exec(queries.getuuid, [insert.insertId])
      .then(rows => res.redirect(`/${rows[0].uuid}/`))
      .catch(err => res.render("index", { languages: [...languages.values()], notification: "lol" }))
    ).catch(err => res.render("index", { languages: [...languages.values()], notification: "didn't insert your paste lol" }));
  });

Map.prototype.getKey = function(val) {
  for (let [key, value] of this)
    if(value.toLowerCase() === val.toLowerCase())
      return key;
  return false;
};